#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2007-2014 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*- eclipse and command line Testing -*-                     #
#                                                                              #
#                                                                              #
# Required global variables:
#   $NAME='PhoneNumber'; #used as node name
#   $TESTPROGRAM='.\\cvisual6\\PhoneNumber.exe';
#   $TESTPROGRAM_ABS='C:\\......\\cvisual6\\PhoneNumber.exe';
#   @OTCFILES = otc file names for C++
#   @COMPILE_SRC = liste des fichiers � compiler
#   @SOURCES = liste des fichiers sources to be linked to the application
#   @EXCLUDE_INSTR_SRC = liste des fichiers � ne pas instrumenter
#   $ATV_INTERMEDIATE_FILE contient la location du fichier .c de la test suite
#   $IS_SEPARATE=0 si le fichier sous test est inclu et 1 si non
#   $REBUILD=1; #=1 means test_harness or settings have changed. =0 means unchanged
#   @COMPILE_SRC=contient la location du  fichier .c de la test suite (compat)
#   @SRC_UNDERTEST=contient les fichiers sous test (.c)
#   si SRC_UNDERTEST contient plus d'un �l�ment IS_SEPARATE=1
################################################################################
# This script is used by Eclipse IDE to build tests and execute-split-report application
# To do output in chronological order when stderr and stdout are both used
use FileHandle;
use File::Spec;
STDOUT->autoflush(1);
STDERR->autoflush(1);

BEGIN {
## globals ############
$TestRTCC=1;
#######################
$LOGFILENAME='TestRT.log';
$STAGE='cptler';
  $ATTMODE=0;
  $ATCMODE=0;
  $ATPMODE=0;
  $ATQMODE=0;
  $ATSMODE=0;
  $ATUMODE=0;
  $ATVMODE=0;
  $ATOMODE=0;
  $ATKMODE=0;
  $ATJMODE=0;
  $ATAMODE=0;
  $ATZMODE=0;
  $ATGMODE=0;
  $DCPMODE=0;
  $MNTMODE=0;
  
$CODE_INSERTION=1;
$ATO_PREPRO_MAX_ERRORS=30;
$PROJECT_NAME='temp';
$PROJECT_PATH='none';
$WORKSPACE_NAME='Local';
$INIFILE='tp.ini';
@OBJECTS=();
}
my $envnode='';
my $CCdefaults=$0;
$CCdefaults=~s,[\\\/]\w+\.pl$,\/BatchCCDefaults.pl,;
require $CCdefaults;
#set minimum required
$XTPFILE = "TestRTccfiles.xtp" unless($XTPFILE);
$TDCFILE;

while (@ARGV) {
    my $arg = shift @ARGV;
	if ($arg=~m/^-config(=)?(.+)?$/) {
		if($1 ne ''){
		    $envnode=$2;
		} else {
		    $envnode=shift(@ARGV);;
		}
		$envnode=~s,\",,g;
		die "unable to open $envnode\n" unless (-f $envnode);
		require $envnode ;
		unless($ENV{'TESTRTDIR'}) {
			my $d=$ATTOLHOME;
			$d=~s,[\\\/]$,,;
			$ENV{'TESTRTDIR'}=$d;
		}
		$ENV{'ATLTGT'}=$TARGETDIR;
	}
	elsif (uc($arg) eq "-WS") {
		$WORKSPACE_DIR=shift @ARGV;
        	$WORKSPACE_DIR=~s,\",,g;
	}
	elsif ($arg=~m/^-WS=(.+)$/i){
		$WORKSPACE_DIR=$1;
		$WORKSPACE_DIR=~s,\",,g;
	}
	elsif (uc($arg) eq "-STAGE") {
		$STAGE=shift @ARGV;
	}
	elsif ($arg=~m/^-stage=(.+)$/i){
		$STAGE=$1;
	}
}
unless ($envnode){
	die "-config option not found. Try -config=\%USERPROFILE\%\\envTestRTcc.pl \n" ;
}
$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
$TARGETDIR=$ENV{ATLTGT};
$LP_TARGETDIR=$ENV{'ATLTGT'};
$INTDIR=$TARGETDIR;$INTDIR=~s,.*[\\\/](\w+)[\\\/]?$,$1,;
$OUTDIR=$INTDIR;
$CONFIGURATION=$INTDIR;
#eclipse var notations
$ENV{workspace_loc}=$WORKSPACE_PATH;
$ENV{ProjDirPath}=$PROJECT_PATH;
@INCLUDE_DIR_LIST=(); #doubled with USER_INCLUDE_DIR_LIST
#since environment variable must be written with $$XX in CDT then convert them to $XX
foreach(@USER_INCLUDE_DIR_LIST,@LIBRARY_DIR_LIST,$LIBRARIES){
	s,\$\$,\$,g; 
    #possible notations:${workspace_loc}/RichardRTP/src/sub.c
	s/\$\{(\w+)\}/$ENV{$1}/g;
    #possible notations:${workspace_loc:/RichardRTP/src/sub.c} $workspace_loc:/RichardRTP/src/sub.c $(workspace_loc)/RichardRTP/src/sub.c
	s/\$\{/\"\$/g;
	s/\}/\"/g;
	s/\$\(?(\w+)\)?\:?/$ENV{$1}/g;
}
  # some options are not available in this mode
#$ATT_ON_THE_FLY=0;

require $SCRIPTDIR . "Source.pl";
require $SCRIPTDIR . "Application.pl";
require $SCRIPTDIR . "VisualTesting.pl";
require $SCRIPTDIR . "metricC.pl";
require $SCRIPTDIR . "readLogFile.pl";


# some settings are modified by the called scripts
my $savATAMODE;
my $savATZMODE;
my $savATGMODE;
my $savDCPMODE;
my $savATTMODE;
my $savATCMODE;
my $savATPMODE;
my $savATQMODE;
my $savATSMODE;
my $savATUMODE;
my $savATVMODE;
my $savATOMODE;
my $savATKMODE;
my $savATJMODE;
my $savMNTMODE;
my @savCOMPLETE_INCLUDE_DIR_LIST;

$BINDIR=GetBinDir() unless($BINDIR);
$BINDIR =  ShortPathName($BINDIR);
$BINPATH=$BINDIR.$PATH_SEPARATOR;
$BINPATH='' if($BINDIR=~/\s/);
$TARGETDIR=ShortPathName($TARGETDIR);
if($WORKING_DIR ne ''){
  chdir($WORKING_DIR);
}

CheckIntDir();
CheckOutDir();
EnterInScript();

$ATTMODE=0 if($Ini{ATTMODE} eq '0');
$ATPMODE=0 if($Ini{ATPMODE} eq '0');
$ATQMODE=0 if($Ini{ATQMODE} eq '0');
$ATCMODE=0 if($Ini{ATCMODE} eq '0');

foreach my $i (@COMPLETE_INCLUDE_DIR_LIST){
	$i=~s/\"//g;
	$i=$WORKSPACE_PATH.$i if(($i =~ /^[\\\/]/) && (!(-d $i))) ;
}

# some settings are modified by the called scripts
$savATAMODE=$ATAMODE;
$savATZMODE=$ATZMODE;
$savATGMODE=$ATGMODE;
$savDCPMODE=$DCPMODE;
$savATTMODE=$ATTMODE;
$savATCMODE=$ATCMODE;
$savATPMODE=$ATPMODE;
$savATQMODE=$ATQMODE;
$savATSMODE=$ATSMODE;
$savATUMODE=$ATUMODE;
$savATVMODE=$ATVMODE;
$savATOMODE=$ATOMODE;
$savATKMODE=$ATKMODE;
$savATJMODE=$ATJMODE;
$savMNTMODE=$MNTMODE;

@savCOMPLETE_INCLUDE_DIR_LIST=@COMPLETE_INCLUDE_DIR_LIST;

if(($LIBRARIES ne '') && defined($Ini{LIBPREFIX}) && ($Ini{LIBPREFIX} ne ',')) {
  my $libprefix=$Ini{LIBPREFIX};
  if($libprefix=~/^[-\/]/) {
     $LIBRARIES = $libprefix.join(' '.$libprefix,split(/[,;]/,$LIBRARIES));
  } else {
     $LIBRARIES = $libprefix.join($libprefix,split(/[,;]/,$LIBRARIES));
  }
}

if($ENV{ATTOLSTUDIO_VERBOSE}){
my $str='';
	$str.='A' if($ATAMODE);
	$str.='Z' if($ATAMODE && $ATZMODE);
	$str.='G' if($ATGMODE);
	$str.='D' if($DCPMODE);
	$str.='T' if($ATTMODE);
	$str.='C' if($ATCMODE);
	$str.='P' if($ATPMODE);
	$str.='Q' if($ATQMODE);
	$str.='K' if($ATKMODE);
	$str.='M' if($ATMMODE);
	$str.='O' if($MNTMODE);
	$str.='R' if($MISRA_MODE);
	$str.='E' if($EXECMODE eq 'DEBUG');
	print "$0\n";
	print "envNode: ",$envnode;
	print " ($str)" if($str ne '');
	print "\nCurrent dir: ", GetCurrentDir() ,"\n";
}
print "Build Configuration: ",$ECLIPSECONFNAME,"\nATLTGT: ",$TARGETDIR,"\n";

my @readyObj;
my $anychangedone;

#ClearLogFile($LOGFILENAME);
open LOG, ">>$LOGFILENAME";
print LOG "DIR ",GetCurrentDir() ,"\n";
close LOG;
if($STAGE =~ /c/){
	print "INTDIR: ",$INTDIR,"\n";
	print "source list:",join(' ',@SOURCES),"\n" if($ENV{ATTOLSTUDIO_VERBOSE});
	print "compile: ",join(' ',@COMPILE_SRC),"\n" if($ENV{ATTOLSTUDIO_VERBOSE});
	print "Include Paths: ",join(',',@COMPLETE_INCLUDE_DIR_LIST),"\n" if($ENV{ATTOLSTUDIO_VERBOSE});
	print "linked with: ",join(' ',@LINKEDFILES),"\n" if($ENV{ATTOLSTUDIO_VERBOSE});
	print "Date:",GetDate(),"\n";
#	print "OTC generation:\n";
	foreach (@OTCFILES){
		buildOt($_) ;
	}

	if($ATVMODE && $ATV_INTERMEDIATE_FILE ne '')
	{
		push (@COMPLETE_INCLUDE_DIR_LIST,"$INTDIR");
		push (@COMPLETE_INCLUDE_DIR_LIST,"$TARGETDIR" . "$PATH_SEPARATOR" . "lib");
	    exit(1) if(TestDriverCompil($ATV_INTERMEDIATE_FILE));
	    $anychangedone=1;
	    if($IS_SEPARATE) {
	    	push(@COMPILE_SRC,@SRC_UNDERTEST) ;
	    } else {
	    	SUTstaticAnalysis(\@SRC_UNDERTEST);
	    }
	}
	if ($STAGE =~ /l/ ){ #link: check non existing obj file to be compiled
	    foreach $FILENAME (@SOURCES){
		unless(grep(/\Q$FILENAME\E/,@COMPILE_SRC)) {
		   unless(grep(/^\Q$FILENAME\E$/,@EXCLUDE_INSTR_SRC)){
		   	push(@COMPILE_SRC,$FILENAME) ; # compile it anyway in order to get generated FDC & TSF files
		   } else {
		    #for file without instrumentation we compile only if object file is older than source
			my ($srcdir, $srcname, $srcext) = SplitFileName( $FILENAME );
			my $obj=$INTDIR.$PATH_SEPARATOR.$srcname.'.'.$OBJEXT;
			if(IsOlderThan($obj,$FILENAME)) {
				print $srcname.'.'.$srcext," need to be re-compiled.\n";
				push(@COMPILE_SRC,$FILENAME) ;
			}else{
				push(@readyObj,$obj);
			}
		   }
		}
	    }
	}
#print "Object file OK:",join(' ',@readyObj),"\n" if($ENV{ATTOLSTUDIO_VERBOSE});

#	my $srcFileCnt=0;
	foreach $FILENAME (@COMPILE_SRC){
		if(grep(/^\Q$FILENAME\E$/,@EXCLUDE_INSTR_SRC)){
			$CODE_INSERTION=0;
		} else {
			setSettings();
		}
		next if($FILENAME eq $ATV_INTERMEDIATE_FILE);# en attendant de le retirer de la liste
		$anychangedone=1;
		exit(1) if(Source());
#		$srcFileCnt++;
	}
	if ($STAGE =~ /l/ ){ #link: build OBJECTS list
		readLogFile('soxb'); #load generated file names from previous compilation
		push( @OBJECTS,@readyObj, @LINKEDFILES);
		setSettings();
	}

	$anychangedone=IsOlderThan($TESTPROGRAM,@OBJECTS) unless($anychangedone );
} else {
	#try to recover FDC and TSF file list
	readLogFile('s');
	#print "TestRT_app> \@TSFFILES=@TSFFILES\n \@FDCFILES=@FDCFILES\n";
}
print &PerlTranslate("TestRT_app.pl", "No TSF file recorded in this configuration, clean and rebuild may help\n","") if(($ATTMODE || $ATPMODE || $ATQMODE || ($ATAMODE && $ATZMODE) || $ATKMODE || ($ATGMODE && $ATG_MODULE_AS)) && scalar(@TSFFILES)==0);
print &PerlTranslate("TestRT_app.pl", "No FDC file recorded in this configuration, clean and rebuild may help\n","") if(($ATCMODE  || $DCPMODE || ($ATGMODE && !$ATG_MODULE_AS))  && scalar(@FDCFILES)==0);
if($ATVMODE) {
	exit(VisualTesting());
} else {
	exit(Application());
}
#---------------------------------------------------
sub SUTstaticAnalysis
{
my $srcList=shift;
 foreach my $src(@$srcList){
   if ( $MISRA_MODE )
   {
	my $res=codeChecker_cc($src);
	print &PerlTranslate("TestRT_app.pl", "code checking Generation failed.\n") if ($res eq "");
   }
   if ( $ATMMODE ) {
	print &PerlTranslate("TestRT_app.pl", "%1: Static Metrics Computing...\n", "%1 is file to be compiled", $srcfile);
	   my ($d,$b,$ext)=SplitFileName($src);
	   my $lang=LanguageOf($ext,$TDP_LANGUAGE);
	my $status=metricsC ($lang, $src, $LOGFILENAME, $OUTDIR);
	print &PerlTranslate("TestRT_app.pl", "Generation  failed. Status $status\n") if ($status);
   }
 }
}

sub setSettings
{
  $ATTMODE=$savATTMODE;
  $ATCMODE=$savATCMODE;
  $ATPMODE=$savATPMODE;
  $ATQMODE=$savATQMODE;
  $ATSMODE=$savATSMODE;
  $ATUMODE=$savATUMODE;
  $ATVMODE=$savATVMODE;
  $ATOMODE=$savATOMODE;
  $ATKMODE=$savATKMODE;
  $ATJMODE=$savATJMODE;
  $ATAMODE=$savATAMODE;
  $ATZMODE=$savATZMODE;
  $ATGMODE=$savATGMODE;
  $DCPMODE=$savDCPMODE;
  $MNTMODE=$savMNTMODE;
  @COMPLETE_INCLUDE_DIR_LIST=@savCOMPLETE_INCLUDE_DIR_LIST;
  $CODE_INSERTION=1;

}

sub buildOt
{
	my $otFile=shift;
	$FILENAME=$otFile;
	my ($fdir,$otname,$otext)=SplitFileName($FILENAME);

	$SRCFILE=$otname.'.'.$otext.'.cpp';
	$OTIFILE=$INTDIR.$PATH_SEPARATOR.$otname.'.'.$otext.'.oti';

	exit(1) if(TestScript());
}

1;
