
sub setMachineVars
{
  $OSNAME = "unix" unless($OSNAME);
  $OS64=0;
  $PATH_SEPARATOR = '/';
  $CLASSPATH_SEPARATOR = ':';
  $OS64=1 if(grep(/_64-linux/,@INC));
  $BINPATH=$BINDIR.$PATH_SEPARATOR;
  $BINPATH='' if($BINDIR=~/\s/);
}

###########################################################################
# System64P
# This routine will print and execute a given command, and
# implicitly return the result
###########################################################################
sub System64P
{
	my @Command=@_;
        my $Ret;

        print join (' ',@Command),"\n" if ($ENV{'ATTOLSTUDIO_VERBOSE'});
        $Ret=system(@Command) unless($showCmd);
        return (ReturnAnalysis($Ret,$Err));
}

###########################################################################
# SystemARCH
# This routine will print and execute a given command, and
# implicitly return the result
###########################################################################
sub SystemARCH
{
	my @Command=@_;
        my $Ret;

        print join (' ',@Command),"\n" if ($ENV{'ATTOLSTUDIO_VERBOSE'});
        $Ret=system(@Command) unless($showCmd);
        return (ReturnAnalysis($Ret,$Err));
}

###########################################################################
# taskExist
# This routine check if a system task is running, and
# return the task PID
###########################################################################
sub taskExist
{
	my $param=shift;
	my @tasklines = `ps -o pid,cmd`;
	my $ret=0;
	foreach(@tasklines)
	{
	   #  2598 pts/3       0:00 bash
#	   if(m/^\s*(\d+)\s+[^:]+:\d+\s+([^\s]+)/){
		# 2598 bash
	   if(m/^\s*(\d+)\s+([^\s]+)/){
	      my $pid=$1;
	      my ($d,$task,$e)=SplitFileName($2);
	      if($task eq $param){
		print $pid,' ',$task,"\n";
		return $pid;
	      }
	   }
	}
	return $ret;
}

################################################################################
# GetCurrentDir
# This function returns the current directory
################################################################################
sub GetCurrentDir
{
#   return TestRTUtil::GetCurrentDir();

    my $CurrentDir;
    $CurrentDir=`pwd`;
    chomp($CurrentDir);
    print &PerlTranslate("Fcts.pl", "WARNING GetCurrentDir doen't return anything contact the support\n") unless ($CurrentDir);

    return $CurrentDir;
}

###########################################################################
# getAppData
# This routine return the directory APPDATA for TestRealTIme
###########################################################################
sub getAppData
{
return $ENV{HOME}."/.TestRealTime/$VERSION";
}
###########################################################################
# JavaExec
# This routine execute the java jar code on the host machine
###########################################################################
sub JavaExec
{
	my $jarfile=shift;
	my $param=shift;
	my $execlog=shift;
	my $libpath=shift;
	my $opt=($jarfile=~m/:/)?"-cp":"-jar";
	my $execlogcmd='';
	$execlogcmd=">\"$execlog\" 2>&1" if((defined $execlog) && ($execlog ne ''));
	if((defined $libpath) && ($libpath ne '')){
		my $prev_LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH};
		my $sep=''; $sep=':' if($prev_LD_LIBRARY_PATH ne '');
		$ENV{LD_LIBRARY_PATH}=$prev_LD_LIBRARY_PATH.$sep.$libpath;
		my $ret=SystemP("\"$TESTRTDIR/jdk/jre/bin/java\" -Djava.library.path=\"$libpath\" $opt $jarfile $param $execlogcmd");
		$ENV{LD_LIBRARY_PATH}=$prev_LD_LIBRARY_PATH;
		return $ret;
	} else {
	return SystemP("\"$TESTRTDIR/jdk/jre/bin/java\" $opt $jarfile $param $execlogcmd");
}
}

###########################################################################
# openBrowser
# This routine open the default browser to view the given file/url
###########################################################################
sub openBrowser
{
my $param=shift;
system("xdg-open $param");
}
1;
