use Win32API::Wow64FsRedirection qw( :ALL );
#This require to have the file Wow64FsRedirection.pm installed into %TESTRTDIR%\lib\perl\Win32API

sub setMachineVars
{
  $OSNAME = "win32" unless($OSNAME);
  $OS64=0;
  if ( $ENV{'ComSpec'} ) {
      ($dir, $name, $ext) = SplitFileName ($ENV{'ComSpec'});
      $dir =~ s/(.*)\\$/$1/;
      $ENV{'PATH'} = $dir . ";" . $ENV{'PATH'};
    } else {
      # Warn end-user
      die &PerlTranslate("Fcts.pl", "Fatal: COMSPEC environment variable not set, cannot find the shell command\n");
    }
  $PATH_SEPARATOR = '\\';
  $CLASSPATH_SEPARATOR = ';';
  $BINDIR=ShortPathName($BINDIR) if($BINDIR=~/\s/);
  $OS64=1 if($ENV{PROCESSOR_ARCHITECTURE} ne 'x86' || defined($ENV{PROCESSOR_ARCHITEW6432}));
  $BINPATH=$BINDIR.$PATH_SEPARATOR;
  $BINPATH='' if($BINDIR=~/\s/);
}
###########################################################################
# System64P
# This routine will print and execute a given command, and
# implicitly return the result
###########################################################################
sub System64P
{
	my @Command=@_;
        my $Ret;

        print join (' ',@Command),"\n" if ($ENV{'ATTOLSTUDIO_VERBOSE'});
        $Ret=system64(@Command) unless($showCmd);
        return (ReturnAnalysis($Ret,$Err));
}

###########################################################################
# SystemARCH
# This routine will print and execute a given command, and
# implicitly return the result
###########################################################################
sub SystemARCH
{
	my @Command=@_;
	my $Ret;

	print join (' ',@Command),"\n" if ($ENV{'ATTOLSTUDIO_VERBOSE'});
	if($ARCH64 && $OS64==0){
		$Ret=system64(@Command) unless($showCmd);
	} else {
		$Ret=system(@Command) unless($showCmd);
	}
	return (ReturnAnalysis($Ret,$Err));
}

###########################################################################
# taskExist
# This routine check if a system task is running, and
# return the task PID
###########################################################################
sub taskExist
{
	my $param=shift;
	my @tasklines = `tasklist /FI \"IMAGENAME eq $param\"`;
	my $ret=0;
	foreach(@tasklines)
	{
	   if(m/^([\w\.]+)\s+(\d+)\s[CS]/){
	      print $2,' ',$1,"\n";
	      $ret=$2;
	   }
	}
	return $ret;
}

################################################################################
# GetCurrentDir
# This function returns the current directory
################################################################################
sub GetCurrentDir
{
#   return TestRTUtil::GetCurrentDir();

    my $CurrentDir;
    $CurrentDir=`cd`;
    chomp($CurrentDir);
    print &PerlTranslate("Fcts.pl", "WARNING GetCurrentDir doen't return anything contact the support\n") unless ($CurrentDir);

    return $CurrentDir;
}

###########################################################################
# getAppData
# This routine return the directory APPDATA for TestRealTIme
###########################################################################
sub getAppData
{
return $ENV{APPDATA}."\\TestRealTime\\$VERSION" if(defined $ENV{APPDATA});
return $ENV{USERPROFILE}."\\AppData\\Roaming\\TestRealTime\\$VERSION";
}

###########################################################################
# JavaExec
# This routine execute the java jar code on the host machine
###########################################################################
sub JavaExec
{
	my $jarfile=shift;
	my $param=shift;
	my $execlog=shift;
	my $libpath=shift;
	my $opt=($jarfile=~m/;/)?"-cp":"-jar";
	my $execlogcmd='';
	$opt="-Djava.library.path=\"$libpath\" ".$opt if((defined $libpath) && ($libpath ne ''));
	$execlogcmd=">\"$execlog\" 2>&1" if((defined $execlog) && ($execlog ne ''));
	return SystemP("\"$TESTRTDIR\\jdk\\jre\\bin\\java.exe\" $opt $jarfile $param $execlogcmd");
}

###########################################################################
# openBrowser
# This routine open the default browser to view the given file/url
###########################################################################
sub openBrowser
{
system(shift);
}
1;
