#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2014 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                      -*-  read log file Script  -*-                        #
#                                                                              #
#                                                                              #
# This script read the $LOGFILENAME to convert to arrays                       #
# normaly generated by studio                                                  #
# These sub are included by scripts when studio is not involved in the process #
#                                                                              #
# Required global variables:                                                   #
#   $LOGFILENAME   : name of the log file to generate.                         #
#                                                                              #
################################################################################

sub readLogFile
{
my $what=shift; #s=TSF+FDC, o=OBJECTS, x=XOB, b=OTSFILES
$what='s' unless($what);
my $d=".";
my $code;
my $f;
  if(open IN, $LOGFILENAME) {
      while(<IN>){
		chomp;
		if(/^DIR\s+(.*)$/) {$d=$1; next;}
		if(/^DUM\s/) {next;}
		if(/^(\w\w\w)\s+(.*)$/) {
			$code=$1;$f=$2;
			$f=$d.'/'.$f unless(-f $f);
			if($code eq 'TSF') {if($what=~m/s/){ push(@TSFFILES,$f) unless( grep(/^\Q$f\E$/,@TSFFILES));} next;}
			if($code eq 'FDC') {if($what=~m/s/){ push(@FDCFILES,$f) unless( grep(/^\Q$f\E$/,@FDCFILES));} next;}
			if($code eq 'OBJ') {if($what=~m/o/){ push(@OBJECTS ,$f) unless( grep(/^\Q$f\E$/,@OBJECTS ));} next;}
			if($code eq 'OTS') {if($what=~m/b/){ push(@OTSFILES,$f) unless( grep(/^\Q$f\E$/,@OTSFILES));} next;}
			if($code eq 'XOB') {if($what=~m/x/){ push(@XOB     ,$f) unless( grep(/^\Q$f\E$/,@XOB     ));} next;}
			if($code eq 'MET') {if($what=~m/m/){ push(@MET     ,$f) unless( grep(/^\Q$f\E$/,@MET     ));} next;}
		}
      }
      close IN;
  }
}

sub cleanLogFile
{
my @rmFiles=@_;
my $currentDir="";
 if(open IN, $LOGFILENAME) {
    my $tsf=( $ATTMODE || $ATPMODE || $ATQMODE || ($ATAMODE && $ATZMODE) || $ATGMODE || $DCPMODE || $ATKMODE );
    my %seen = ();
    foreach(@rmFiles){$seen{$_}++;}
    open OU, ">$LOGFILENAME.tmp" or die &PerlTranslate("trtsplit.pl", "cannot write the temp log file.\n");
    while(<IN>){
	if(/(SVS|INC|DEF|FLG|#OPT|#TGT|#TDP|DTT|)\s/){print OU;next}
	chomp;
	if(/(\w{3})\s+(.+)$/){
	   my $tk=$1;
	   if(($currentDir=="") && ($tk eq 'DIR')) {
			$currentDir=$2;
	   }
	   my $pt=absolutePath($2,$currentDir);
	   unless( $seen{$pt}++){
		if(($tk eq 'DUM') && !($KEEP)) {
			# unlink absolute and relative files
			if (-f $pt) {
				unlink($pt);
#			} else {
#				unlink($currentDir."/".$2);
			}
		}
		elsif(($tk eq 'TDF') && !(-f $pt)){} #remove the line if the file has been splitted
		else {print OU "$tk $2\n" ;}
	   }
	} else {
	    print "unknown line in log file $_\n";
	}
   }
   close IN;
   close OU;
   rename($LOGFILENAME.'.tmp',$LOGFILENAME);
 } else {
	&PerlTranslate("trtsplit.pl", "No result log found.\n");
 }
}
# list of tokens used to populate the LOG file
#---- information NOT a file
#DIR gives default directory for following relativ path
##TGT comment giving ATLTGT env var
##OPT comment giving instrum features used
##TDP tdp name
#DTT Date
#INC include path used
#FLG compil flags used
#DEF macro define used
#SVS source file version
##OK global test result
#---- code gen
#SRC generated source file
#OTI Object testing instrum directives
#---- intrum Gen
#FDC Coverage static file
#TSF other instrum static file
#---- code cheker
#XOB xml object code checker
#CRC code checker result XRD format
#CRX code checker result XML format
##---- exec results
#SPT execution result befor split
#TDF Dynamic trace results
#TIO coverage results
#TPF Purify results
#TQF Quantify results
#ERR unsplit lines
#TGF Ctrl coupling unit results
#TZF Stack size results
#DCP Data coupling results
#CCF Ctrl coupling func results
#RIO PTU test results
#RI2 Previous PTU test results for compare mode
#---- postpro
#ROD intermediate PTU test results after postpro
#XRD PTU test results after postpro
#COR Rtist color file
#TXF java Purify
#---- reports
#TGX ctrl coupling report
#TGJ ctrl coupling json report
#DCX data coupling report
#DCJ data coupling json report
#TZX stack size report
#TZJ stack size json report
#TQX quantify WCET report
#TQJ quantify WCET json report
#COX coverage XML report
#---- Build
#ENV env_TestRTcc.pl file used
#LOG build console log
#OPT option file used for instrum
#MNT monitoring generated file
#OBJ object file
#EXE executable file
#LIB library file
#DUM Dummy file
#JPT java
#MET metric
#OTS object test static file
#ADA ada generated file

1;
